      character :: dmy
      character :: asp
      real, allocatable :: rx(:),ry(:),rz(:)
      real, allocatable :: qx(:),qy(:),qz(:)
      real :: hmat(3,3),hinmat(3,3)

      aa=4.05

      read (5,*) asp
      read (5,*) dmy
      read (5,*) n
      allocate (rx(n),ry(n),rz(n),qx(n),qy(n),qz(n))
      do j=1,3
         read (5,*) xx,yy,zz
         hmat(1,j)=xx; hmat(2,j)=yy; hmat(3,j)=zz
      enddo
      do i=1,n
         read (5,*) xx,yy,zz
         rx(i)=xx; ry(i)=yy; rz(i)=zz
      enddo
      call inverse(hmat,hinmat)
      do i=1,n
         qx(i)=hinmat(1,1)*rx(i)+hinmat(1,2)*ry(i)+hinmat(1,3)*rz(i)
         qy(i)=hinmat(2,1)*rx(i)+hinmat(2,2)*ry(i)+hinmat(2,3)*rz(i)
         qz(i)=hinmat(3,1)*rx(i)+hinmat(3,2)*ry(i)+hinmat(3,3)*rz(i)
      enddo
      hmat=hmat/aa

      

      write (6,*) asp
      write (6,*) aa
      write (6,*) hmat(1,1),hmat(2,1),hmat(3,1)
      write (6,*) hmat(1,2),hmat(2,2),hmat(3,2)
      write (6,*) hmat(1,3),hmat(2,3),hmat(3,3)
      write (6,*) n
      write (6,*) dmy
      do i=1,n
         write (6,*) qx(i),qy(i),qz(i)
      enddo
      

      end

      subroutine inverse(a,b)
      real a(3,3),b(3,3)
      do i=1,3
         do j=1,3
            b(i,j)=a(i,j)
         enddo
      enddo
      do 100 k=1,3
         p=b(k,k)
         b(k,k)=1.0d0
         do 1 j=1,3
            b(k,j)=b(k,j)/p
 1       continue
         do 2 i=1,3
            if (i.ne.k) then
               q=b(i,k)
               b(i,k)=0.0d0
               do 3 j=1,3
                  b(i,j)=b(i,j)-q*b(k,j)
 3             continue
            endif
 2       continue
 100  continue
      return
      end
